/* gcc -fPIC -shared -O4 -pipe -s -o tls10.so tls10.c  */

#include <stdio.h>
#include <dlfcn.h>
#include <openssl/ssl.h>

#include "ssl_locl.h"

static void *ssl_handle = NULL;    
typedef SSL_CTX* (*ssl_ctx_new_type)(const SSL_METHOD*);
ssl_ctx_new_type ssl_ctx_new_real;
static int ssl_ctx_new_real_init = 0;

SSL_CTX *SSL_CTX_new(const SSL_METHOD* meth)
{
    if (! ssl_ctx_new_real_init)
    {
        if ((ssl_handle = dlopen("libssl.so", RTLD_LAZY)))
            { if (! (ssl_ctx_new_real = dlsym(ssl_handle, "SSL_CTX_new"))) { fprintf(stderr, "tls10: can not find SSL_CTX_new()\n"); return NULL; } }
        else
            { fprintf(stderr, "%s\n", dlerror()); }
    }

    if (meth->version == TLS_ANY_VERSION) return ssl_ctx_new_real(TLSv1_method());

    printf("%i %u %lu\n", meth->version, meth->flags, meth->mask);

    return ssl_ctx_new_real(meth);
}
